import * as i0 from '@angular/core';
import { Component, Input, ViewChild, Directive, HostListener, NgModule } from '@angular/core';

class UploadDropzoneComponent {
    constructor() {
        this.width = "600px";
        this.height = "375px";
    }
    ngAfterViewInit() {
        const onUpdateParams = this.onUpdate === undefined ? {} : { onUpdate: this.onUpdate };
        this.getUploader()
            .open({
            ...(this.options !== undefined ? this.options : {}),
            ...onUpdateParams,
            container: this.container.nativeElement,
            layout: "inline"
        })
            .then(files => {
            if (this.onComplete !== undefined) {
                this.onComplete(files);
            }
        }, error => console.error("Uploader error.", error));
    }
    getUploader() {
        if (this.uploader === undefined) {
            throw new Error("[angular-uploader] You must provide the 'uploader' attribute to the 'UploadDropzone' component.");
        }
        return this.uploader;
    }
}
UploadDropzoneComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.1", ngImport: i0, type: UploadDropzoneComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
UploadDropzoneComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.1", type: UploadDropzoneComponent, selector: "upload-dropzone", inputs: { options: "options", uploader: "uploader", onComplete: "onComplete", onUpdate: "onUpdate", width: "width", height: "height" }, viewQueries: [{ propertyName: "container", first: true, predicate: ["container"], descendants: true }], ngImport: i0, template: `
    <div #container style="position: relative; width: 100%; maxWidth: {{ width }}; height: {{ height }}"></div>
  `, isInline: true });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.1", ngImport: i0, type: UploadDropzoneComponent, decorators: [{
            type: Component,
            args: [{
                    selector: "upload-dropzone",
                    template: `
    <div #container style="position: relative; width: 100%; maxWidth: {{ width }}; height: {{ height }}"></div>
  `,
                    styles: []
                }]
        }], propDecorators: { options: [{
                type: Input,
                args: ["options"]
            }], uploader: [{
                type: Input,
                args: ["uploader"]
            }], onComplete: [{
                type: Input,
                args: ["onComplete"]
            }], onUpdate: [{
                type: Input,
                args: ["onUpdate"]
            }], width: [{
                type: Input,
                args: ["width"]
            }], height: [{
                type: Input,
                args: ["height"]
            }], container: [{
                type: ViewChild,
                args: ["container"]
            }] } });

class UploadButtonDirective {
    onClick(event) {
        event.preventDefault();
        this.getUploader()
            .open(this.options)
            .then(files => {
            if (this.onComplete !== undefined) {
                this.onComplete(files);
            }
        }, error => console.error("Uploader error.", error));
    }
    ngOnInit() {
        try {
            this.getUploader();
        }
        catch (e) {
            console.error(e);
        }
    }
    getUploader() {
        if (this.uploader === undefined) {
            throw new Error("[angular-uploader] You must provide the 'uploader' attribute to elements marked with the 'uploadButton' directive.");
        }
        return this.uploader;
    }
}
UploadButtonDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.1", ngImport: i0, type: UploadButtonDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive });
UploadButtonDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.1", type: UploadButtonDirective, selector: "[uploadButton]", inputs: { options: ["uploadOptions", "options"], uploader: "uploader", onComplete: ["uploadComplete", "onComplete"] }, host: { listeners: { "click": "onClick($event)" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.1", ngImport: i0, type: UploadButtonDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: "[uploadButton]"
                }]
        }], propDecorators: { options: [{
                type: Input,
                args: ["uploadOptions"]
            }], uploader: [{
                type: Input,
                args: ["uploader"]
            }], onComplete: [{
                type: Input,
                args: ["uploadComplete"]
            }], onClick: [{
                type: HostListener,
                args: ["click", ["$event"]]
            }] } });

class UploaderModule {
}
UploaderModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.1", ngImport: i0, type: UploaderModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
UploaderModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.1", ngImport: i0, type: UploaderModule, declarations: [UploadDropzoneComponent, UploadButtonDirective], exports: [UploadDropzoneComponent, UploadButtonDirective] });
UploaderModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.1", ngImport: i0, type: UploaderModule, imports: [[]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.1", ngImport: i0, type: UploaderModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UploadDropzoneComponent, UploadButtonDirective],
                    imports: [],
                    exports: [UploadDropzoneComponent, UploadButtonDirective]
                }]
        }] });

/*
 * Public API Surface of angular-uploader
 */

/**
 * Generated bundle index. Do not edit.
 */

export { UploadButtonDirective, UploadDropzoneComponent, UploaderModule };
//# sourceMappingURL=angular-uploader.mjs.map
